/**
# Nioi Pier Giuliano, piergiuliano@gmail.com , eple programming language environment.
# Thesis project, feb.2013
*/

/**
 * Visual Blocks Editor
 *
 * Copyright 2012 Google Inc.
 * http://blockly.googlecode.com/
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 * @fileoverview JavaScript for Blockly code demo (langaue-neutral).
 * @author fraser@google.com (Neil Fraser)
 */

/**
 * Initialize Blockly.  Called on page load.
 * @param {!Blockly} blockly Instance of Blockly from iframe.
 */
 var Blockly=null;
 var VisualizerRef=null;
 var bind=null;
 var unbind=null;
 
 function setER(er){
 	window.Blockly = er;
 	
	// An href with #key trigers an AJAX call to retrieve saved blocks.
	 if (window.location.hash.length > 1) {
			 BlocklyStorage.retrieveXml(window.location.hash.substring(1));
	} else {
			  // Restore saved blocks in a separate thread so that subsequent
		  // initialization is not affected from a failed load.
			  window.setTimeout(BlocklyStorage.restoreBlocks, 0);
	  }
  // Hook a save function onto unload.
   BlocklyStorage.backupOnUnload();
   
 }

function setVR(vr){
 	window.VisualizerRef = vr;
 }

/**
* Called to load a specified program
*/
function tryToLoad(args) {
	var input = prompt("Please enter the code that follows the #","something like   'if9gdg'    ");
	if(input){
		loadThatXmlIntoDom(input);
	}
}

/**
* Call this to load saved work if hashtag is present in URL and Storage Enabled
*/
function loadThatXmlIntoDom(key) {
        BlocklyStorage.retrieveXml(key);
}

/**
 * Generate the code from the workspace, pass it to the backend and render 
 * the JSON returned.
 */
function sendCode() {
	
	//retrieving the python code induced by workspace, from the generator
  var code = Blockly.Generator.workspaceToCode('Python');
  //alert(code);
  
  $.post('/exec',
        {user_script : code,
         cumulative_mode: $('#cumulativeModeSelector').val(),
         heap_primitives: $('#heapPrimitivesSelector').val()},
        function(dataFromBackend) {
          var trace = dataFromBackend.trace;
          VisualizerRef.visualize(dataFromBackend);
          },
        "json");//END OF GET
  
  
}